<?php

/**************************************************

 * C O R E   S E C T I O N   D E V E L O P M E N T

 *-------------------------------------------------

 * File: db.class.php --> PHP5 file.

 * Program: auctionhouse ffxi

 *------------------------------------------------

 *                 Copyright 2012 Core Section Inc.

 * ID: FFXAH100

 *************************************************/







	/* This file defines the Database Access class.

	   Currently, the class is setup to access mysql databases only

	   but when there's time, further database types may be included.

	*/



  /*

   * __construct()

   * Link private dbConnect()

   * int updateDb(string $query)

   * array queryDb(string $query)

   * int countRows(string $query)

   * int findNextAutoIncrement(string $table)

   * string getTablePrefix()

   */

  class Db

  {

    private $server, $user, $pass, $dbname, $dbprefix;



    /* Constructor - Uses db.config.php to read

     * necessary variables for database connection

     */

    public function __construct()

    {

      require 'db.config.php';

      $this->server = $server;

      $this->user = $user;

      $this->pass = $pass;

      $this->dbname = $dbname;

      $this->dbprefix = $dbprefix;



    }//end constructor



    /* Establishes connection to the database*/

    private function dbConnect()

    {

      $link = mysql_connect($this->server, $this->user, $this->pass);

      if (!mysql_select_db($this->dbname, $link)) 

      {

        throw new Exception(mysql_error()." DB NAME ATTEMPTED: ".$this->dbname);

      }

      return $link;

    }



    /* for anything that the mysql library would return true/false

     * use this one for anything where an actual result is

     * returned, further processing will be done. This does not 

     * return true/false, but returns the number of rows affected

     * by the query. -1 means the query failed.

     */

    public function updateDb($query)

    {

      $link = $this->dbConnect();

      $result = (bool)mysql_query($query, $link); 

      if ($result) 

        $result = mysql_affected_rows();

      else

      {

        throw new Exception (mysql_error($link).' Query: '.$query);

      }

      mysql_close();

	

      return $result;

    }



    /* This is for selecting an array of values. Most select 

     * statements will use this as it returns the information.

     */

    public function queryDb($query)

    {

      $link = $this->dbConnect();

      $result = mysql_query($query, $link);

      if ($result)

      {

        $data = array();

	$count = mysql_num_rows($result);

	for ($i=0; $i<$count; $i++)

	{

	  $data[$i] = mysql_fetch_array($result);

	}//end for

      }//end if

      else

      {

        throw new Exception(mysql_error().' '.$query);

      }//end else

      mysql_close();

      mysql_free_result($result);



      return $data;

    }//end query_db



    /* This returns a count of rows queried by the query */

    public function countRows($query)

    {

      $link = $this->dbConnect();

      $resource = mysql_query($query, $link) or die(mysql_error());

      $result = mysql_num_rows($resource);

      if (!$result)

      {

        $result = 0;

      }//end if

			

      return $result;

    }//end count_rows



    public function findNextAutoIncrement($table)

    {

      $query = "SHOW TABLE STATUS";

      $result = $this->queryDb($query);

      $nextIncr = 0;

      foreach ($result as $line)

      {

        if ($line['Name'] == $this->dbprefix.$table)

	{

	  $nextIncr = $line['Auto_increment'];

	}//end if

      }//end foreach



      return $nextIncr;

    }//end findNextAutoIncrement



    /* Returns the table prefix */

    public function getTablePrefix()

    {

      return $this->dbprefix;

    }//end get_table_prefix



	public function getDBsize() {

		$query = "SHOW TABLE STATUS";

		$result = $this->queryDb($query);

		$dbsize = 0;

		foreach ($result as $rx) {

			$dbsize += $rx['Data_length'] + $rx['Index_length'];

		}

		return $dbsize;

	}



  }//end Class Db



/* -> Additional functions <- */



?>

